#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

#include "myincludes.h"

#define HEX_A 10
#define HEX_B 11
#define HEX_C 12
#define HEX_D 13
#define HEX_E 14
#define HEX_F 15

krypto::krypto(void)
{
slim=false;
OutPutFile=new char();
if (!OutPutFile)
    {fprintf(stderr, "\nNot enough memory...\n");abort();}
OutPutFile="";
}
//-----------------------------------
//-----------------------------------
void krypto::genList(char *key)
{
int th1, x, f1=3,f2=3,f3=3, f4=3;
/*
*es gilt:
*	f2 > (f1 <> f3) > f4
*/

//Listen fllen
for (int i=0;i<128;i++)
  {
  thlist[i]=i;
  thlist1[i]=i+128;
  }

//faktoren f1 - f4 aus Passwort generieren
for (int i=0;i<len(key);i++)
      {f1+=key[i];
       if (i > 0)
        f2+=key[i]*key[i-1];
       f3+=f2 % f1;
      }
 f4+=f2%f3;
 while (2*f4>f3 || 2*f4>f1)
        f4-=3;

//Listen unter Bercksichtigung von f1 - f4 mischen
for (int i=0;i<128;i++)
 {
  x = f2-f1-f3-f4;
  while (x>=256)
         x=x/2;
      x=abs(x-128);
  th1=thlist[i];
  thlist[i]=thlist1[x];
  thlist1[x]=th1;

  //f1 - f4 neu generieren)
  f4 = 3 + (f2 % (i + 17));
  f1 = 3 + (f4 * 17);
  f3 = 3 + (f2 % f1);
  f2 = 3 + (f1 * f3);
 }

//hexlisten mit den (bereits gemischten) Werten aus thlist fllen
for (int i=0;i<16;i++)
     {
      hexlist0[i]=thlist[i+16*0];
      hexlist1[i]=thlist[i+16*1];
      hexlist2[i]=thlist[i+16*2];
      hexlist3[i]=thlist[i+16*3];
      hexlist4[i]=thlist[i+16*4];
      hexlist5[i]=thlist[i+16*5];
      hexlist6[i]=thlist[i+16*6];
      hexlist7[i]=thlist[i+16*7];

      hexlist8[i]=thlist1[i+16*0];
      hexlist9[i]=thlist1[i+16*1];
      hexlistA[i]=thlist1[i+16*2];
      hexlistB[i]=thlist1[i+16*3];
      hexlistC[i]=thlist1[i+16*4];
      hexlistD[i]=thlist1[i+16*5];
      hexlistE[i]=thlist1[i+16*6];
      hexlistF[i]=thlist1[i+16*7];
     }

}

//----------------------------------------------------------
//----------------------------------------------------------

bool krypto::is1(int ix)
 {
  for (int i=0;i<128;i++)
   {
    if(thlist1[i]==ix)
       return true;
   }
  return false;
 }
//----------------------------------------------------------
//----------------------------------------------------------

void krypto::encrypt(char *key)
{
fprintf (stderr, "krypto will encrypt the specified file\n");
genList(key);
FILE *f, *fOut;

if (OutPutFile[0]==0)
    {sprintf (OutPutFile,"%s.kr", FileName);}

f=fopen (FileName, "r");
fOut=fopen (OutPutFile, "w");

if (f==NULL)
    {fprintf(stderr, "\n\nError opening the file %s...\n", FileName); abort();}
if (fOut==NULL)
    {fprintf(stderr, "\n\nCan't write to File %s...\n", OutPutFile); abort();}

int it/*binr konvertierung*/, keyPos=len(key);
bool sBin[8];
char hBin[2];

if (slim) {fprintf(stderr, "\nSlim encryption\n");putc(1, fOut);}
else      {fprintf(stderr, "\nNormal encryption\n");putc(0, fOut);}


while (!feof(f))
	{
if (keyPos==0)
    it=getc(f);
else
    {
     keyPos--;
     it=key[keyPos];
    }

if (it != -1)
    {
//slim
if (slim)
    {
     if (it==EOF)
         {delete f;delete fOut;return;}
     //erste Hexstelle
     if (it>=16)
         {
          switch (it/16)
	   {
	    case 1:
	       putc(getHex(1), fOut);
	       break;
	    case 2:
	       putc(getHex(2), fOut);
	       break;
	    case 3:
	       putc(getHex(3), fOut);
	       break;
	    case 4:
	       putc(getHex(4), fOut);
	       break;
	    case 5:
	       putc(getHex(5), fOut);
	       break;
	    case 6:
	       putc(getHex(6), fOut);
	       break;
	    case 7:
	       putc(getHex(7), fOut);
	       break;
	    case 8:
	       putc(getHex(8), fOut);
	       break;
	    case 9:
	       putc(getHex(9), fOut);
	       break;
	    case 10:
	       putc(getHex(HEX_A), fOut);
	       break;
	    case 11:
	       putc(getHex(HEX_B), fOut);
	       break;
	    case 12:
	       putc(getHex(HEX_C), fOut);
	       break;
	    case 13:
	       putc(getHex(HEX_D), fOut);
	       break;
	    case 14:
	       putc(getHex(HEX_E), fOut);
	       break;
	    case 15:
	       putc(getHex(HEX_F), fOut);
	       break;
	    }
	    it=it%16;
	   }
          else
	    putc(getHex(0), fOut);

     //zweite Hexstelle
     if (it >= 1)
	 {
          switch (it/1)
	   {
	    case 1:
	       putc(getHex(1), fOut);
	       break;
	    case 2:
	       putc(getHex(2), fOut);
	       break;
	    case 3:
	       putc(getHex(3), fOut);
	       break;
	    case 4:
	       putc(getHex(4), fOut);
	       break;
	    case 5:
	       putc(getHex(5), fOut);
	       break;
	    case 6:
	       putc(getHex(6), fOut);
	       break;
	    case 7:
	       putc(getHex(7), fOut);
	       break;
	    case 8:
	       putc(getHex(8), fOut);
	       break;
	    case 9:
	       putc(getHex(9), fOut);
	       break;
	    case 10:
	       putc(getHex(HEX_A), fOut);
	       break;
	    case 11:
	       putc(getHex(HEX_B), fOut);
	       break;
	    case 12:
	       putc(getHex(HEX_C), fOut);
	       break;
	    case 13:
	       putc(getHex(HEX_D), fOut);
	       break;
	    case 14:
	       putc(getHex(HEX_E), fOut);
	       break;
	    case 15:
	       putc(getHex(HEX_F), fOut);
	       break;
	   }
	 }
	else
	  putc(getHex(0), fOut);
    }
//normal
else
{
	sBin[0]=0;
	sBin[1]=0;
	sBin[2]=0;
	sBin[3]=0;
	sBin[4]=0;
	sBin[5]=0;
	sBin[6]=0;
	sBin[7]=0;

	if (it >= 128)
	    {
	     sBin[0]=1;
	     it=it % 128;
	    }
	if (it >= 64)
	    {
	     sBin[1]=1;
	     it=it % 64;
	    }
	if (it >= 32)
	    {
	     sBin[2]=1;
	     it=it % 32;
	    }
	if (it >= 16)
	    {
	     sBin[3]=1;
	     it=it % 16;
	    }
	if (it >= 8)
	    {
	     sBin[4]=1;
	     it=it % 8;
	    }
	if (it >= 4)
	    {
	     sBin[5]=1;
	     it=it % 4;
	    }
	if (it >= 2)
	    {
	     sBin[6]=1;
	     it=it % 2;
	    }
	if (it >= 1)
	    {
	     sBin[7]=1;
	    }

	for (int i=0;i<=7;i++)
	     {
	     if (sBin[i])
	         {
     putc (get1(), fOut);
		 }
	     else
	     	{
		  putc (get0(), fOut);
		}

	     }

	}
}
}
delete fOut;
delete f;
}
//----------------------------------------------------------
//----------------------------------------------------------
void krypto::decrypt(char *key)
{
genList(key);

fprintf (stderr, "krypto will decrypt the specified file\n");
FILE *f=fopen(FileName, "r");

if (f==NULL)
    {fprintf(stderr, "\n\nError opening the file %s...\n", FileName); abort();}

int it=getc(f), keyPos=len(key);
    if (it==1) slim=true;
    else       slim=false;

unsigned char sBin[8], hBin;

while (!feof(f))
{
it=0;
hBin=0;
if (slim)
   {
    it=fgetc(f);    //1.hexstelle
    if (it==EOF) {delete f; return;}

    switch (getCharHex(it))
       {
        case '0':
	  break;
        case '1':
          hBin+=(1*16);
	  break;
        case '2':
          hBin+=(2*16);
	  break;
        case '3':
          hBin+=(3*16);
	  break;
        case '4':
          hBin+=(4*16);
	  break;
        case '5':
          hBin+=(5*16);
	  break;
        case '6':
          hBin+=(6*16);
	  break;
        case '7':
          hBin+=(7*16);
	  break;
        case '8':
          hBin+=(8*16);
	  break;
        case '9':
          hBin+=(9*16);
	  break;
        case 'A':
          hBin+=(HEX_A*16);
	  break;
        case 'B':
          hBin+=(HEX_B*16);
	  break;
        case 'C':
          hBin+=(HEX_C*16);
	  break;
        case 'D':
          hBin+=(HEX_D*16);
	  break;
        case 'E':
          hBin+=(HEX_E*16);
	  break;
        case 'F':
          hBin+=(HEX_F*16);
	  break;
	default:
	  fprintf(stderr, "\nFehler in Funktion 'decrypt'(switch1): unerwarteter Wert: %i\n", hBin);
	  abort();
	  break;
       }

    it=fgetc(f); //2. hexstelle
    if (it==EOF) {delete f; return;}
        switch (getCharHex(it))
       {
        case '0':
	  break;
        case '1':
          hBin+=1;
	  break;
        case '2':
          hBin+=2;
	  break;
        case '3':
          hBin+=3;
	  break;
        case '4':
          hBin+=4;
	  break;
        case '5':
          hBin+=5;
	  break;
        case '6':
          hBin+=6;
	  break;
        case '7':
          hBin+=7;
	  break;
        case '8':
          hBin+=8;
	  break;
        case '9':
          hBin+=9;
	  break;
        case 'A':
          hBin+=HEX_A;
	  break;
        case 'B':
          hBin+=HEX_B;
	  break;
        case 'C':
          hBin+=HEX_C;
	  break;
        case 'D':
          hBin+=HEX_D;
	  break;
        case 'E':
          hBin+=HEX_E;
	  break;
        case 'F':
          hBin+=HEX_F;
	  break;
	default:
	  fprintf(stderr, "\nFehler in Funktion 'decrypt'(switch2): unerwarteter Wert: %i\n", hBin);
	  abort();
	  break;
       }
	//Ausgabe:
       it = hBin;
   }
else
{
	sBin[0]=fgetc(f);
	if (feof(f)){delete f; return;}
 	sBin[1]=fgetc(f);
	if (feof(f)){delete f; return;}
 	sBin[2]=fgetc(f);
	if (feof(f)){delete f; return;}
 	sBin[3]=fgetc(f);
	if (feof(f)){delete f; return;}
 	sBin[4]=fgetc(f);
	if (feof(f)){delete f; return;}
 	sBin[5]=fgetc(f);
	if (feof(f)){delete f; return;}
 	sBin[6]=fgetc(f);
	if (feof(f)){delete f; return;}
 	sBin[7]=fgetc(f);

if (is1(sBin[0]))
    it+=128;
if (is1(sBin[1]))
    it+=64;
if (is1(sBin[2]))
    it+=32;
if (is1(sBin[3]))
    it+=16;
if (is1(sBin[4]))
    it+=8;
if (is1(sBin[5]))
    it+=4;
if (is1(sBin[6]))
    it+=2;
if (is1(sBin[7]))
    it+=1;
/**/}

       if (keyPos==0)
           printf ("%c", it);
       else
          {
           keyPos--;
	   if(key[keyPos]!=it)
	      {fprintf (stderr, "\nFalsches Passwort...\n");abort();}
           //letzter durchlauf
	   if (keyPos==0)
	       if (slim) fprintf(stderr, "\nSlim decryption\n");
	       else      fprintf(stderr, "\nNormal decryption\n");
	  }
}

delete f;
}

//-----------------------------------
//-----------------------------------
int krypto::getIndex0(unsigned char th)
{
 for (int i=0;i<128;i++)
      if (th==thlist[i]) return i;
 //not found
 return -1;
}
//-----------------------------------
//-----------------------------------
int krypto::getIndex1(unsigned char th)
{
 for (int i=0;i<128;i++)
      if (th==thlist1[i]) return i;
 //not found
 return -1;
}

unsigned char krypto::getHex(int which)
{
int x=rand();
while (x>=32)
       x=x/2;
       x=abs(x-16);

switch (which)
	{
	case 0:
	  return hexlist0[x];
	  break;
	case 1:
	  return hexlist1[x];
	  break;
	case 2:
	  return hexlist2[x];
	  break;
	case 3:
	  return hexlist3[x];
	  break;
	case 4:
	  return hexlist4[x];
	  break;
	case 5:
	  return hexlist5[x];
	  break;
	case 6:
	  return hexlist6[x];
	  break;
	case 7:
	  return hexlist7[x];
	  break;
	case 8:
	  return hexlist8[x];
	  break;
	case 9:
	  return hexlist9[x];
	  break;
	case HEX_A:
	  return hexlistA[x];
	  break;
	case HEX_B:
	  return hexlistB[x];
	  break;
	case HEX_C:
	  return hexlistC[x];
	  break;
	case HEX_D:
	  return hexlistD[x];
	  break;
	case HEX_E:
	  return hexlistE[x];
	  break;
	case HEX_F:
	  return hexlistF[x];
	  break;
	default:
	  fprintf (stderr, "\nFehler in Funktion getHex: Argument 'which'(=%i) ist < 1 und > 15\n", which);
	  abort();
          return false;
	  break;
	}
}
//----------------------------------------------------------
//----------------------------------------------------------
unsigned char krypto::get0()
{
 int x=rand();
 while (x>=256)
        x=x/2;
	x=abs(x-128);
 return  thlist[x];
}
//----------------------------------------------------------
//----------------------------------------------------------
unsigned char krypto::get1()
{
 int x=rand();
 while(x>=256)
       x=x/2;
       x=abs(x-128);
 return  thlist1[x];
}
//------------------------------------------------------------
//------------------------------------------------------------
unsigned char krypto::getCharHex(unsigned char th)
   {
    for (int i=0;i<16;i++)
         if (hexlist0[i]==th)
	     return '0';
    //---------------
    for (int i=0;i<16;i++)
         if (hexlist1[i]==th)
	     return '1';
    //---------------
    for (int i=0;i<16;i++)
         if (hexlist2[i]==th)
	     return '2';
    //---------------
    for (int i=0;i<16;i++)
         if (hexlist3[i]==th)
	     return '3';
    //---------------
    for (int i=0;i<16;i++)
         if (hexlist4[i]==th)
	     return '4';
    //---------------
    for (int i=0;i<16;i++)
         if (hexlist5[i]==th)
	     return '5';
    //---------------
    for (int i=0;i<16;i++)
         if (hexlist6[i]==th)
	     return '6';
    //---------------
    for (int i=0;i<16;i++)
         if (hexlist7[i]==th)
	     return '7';
    //---------------
    for (int i = 0;i<16; i++)
         if (hexlist8[i]==th)
	     return '8';
    //---------------
    for (int i=0;i<16;i++)
         if (hexlist9[i]==th)
	     return '9';
    //---------------
    for (int i=0;i<16;i++)
         if (hexlistA[i]==th)
	     return 'A';
    //---------------
    for (int i=0;i<16;i++)
         if (hexlistB[i]==th)
	     return 'B';
    //---------------
    for (int i=0;i<16;i++)
         if (hexlistC[i]==th)
	     return 'C';
    //---------------
    for (int i=0;i<16;i++)
         if (hexlistD[i]==th)
	     return 'D';
    //---------------
    for (int i=0;i<16;i++)
         if (hexlistE[i]==th)
	     return 'E';
    //---------------
    for (int i=0;i<16;i++)
         if (hexlistF[i]==th)
	     return 'F';

    fprintf (stderr, "\nFehler in Funktion getCharHex: Wert %i lsst sich nicht zuordnen.\n", th);
    return 'f';
   }


